#include "common.ch"
#include "os.ch"
#define CRLF CHR(13)+CHR(10)

#PRAGMA LIBRARY("ASCOM10.LIB")


PROCEDURE Main(strComputer,cUser,cPassword)
LOCAL objWMIServices
LOCAL colItems
LOCAL cText
LOCAL cName
LOCAL bCollBlock
LOCAL i,iMax
LOCAL j,jMax
LOCAL aitem := {}
LOCAL aProp := {;
"BootDevice",;
"BuildNumber",;
"BuildType",;
"Caption",;
"CodeSet",;
"CountryCode",;
"CreationClassName",;
"CSCreationClassName",;
"CSDVersion",;
"CSName",;
"CurrentTimeZone",;
"DataExecutionPrevention_32BitApplications",;
"DataExecutionPrevention_Available",;
"DataExecutionPrevention_Drivers",;
"DataExecutionPrevention_SupportPolicy",;
"Debug",;
"Description",;
"Distributed",;
"EncryptionLevel",;
"ForegroundApplicationBoost",;
"FreePhysicalMemory",;
"FreeSpaceInPagingFiles",;
"FreeVirtualMemory",;
"InstallDate",;
"LargeSystemCache",;
"LastBootUpTime",;
"LocalDateTime",;
"Locale",;
"Manufacturer",;
"MaxNumberOfProcesses",;
"MaxProcessMemorySize",;
"Name",;
"NumberOfLicensedUsers",;
"NumberOfProcesses",;
"NumberOfUsers",;
"Organization",;
"OSLanguage",;
"OSProductSuite",;
"OSType",;
"OtherTypeDescription",;
"PlusProductID",;
"PlusVersionNumber",;
"Primary",;
"ProductType",;
"QuantumLength",;
"QuantumType",;
"RegisteredUser",;
"SerialNumber",;
"ServicePackMajorVersion",;
"ServicePackMinorVersion",;
"SizeStoredInPagingFiles",;
"Status",;
"SuiteMask",;
"SystemDevice",;
"SystemDirectory",;
"SystemDrive",;
"TotalSwapSpaceSize",;
"TotalVirtualMemorySize",;
"TotalVisibleMemorySize",;
"Version" }

DEFAULT strComputer TO "Localhost"
DEFAULT cUser       TO "Administrator"
DEFAULT cPassword   TO ""

   CLS

   SET ALTER TO Win32_OperatingSystem.TXT
   SET ALTER ON

   IF VAL( OS(OS_VERSION) ) > 6
      IF strComputer == "Localhost"
         objWMIServices  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2")
      ELSE
         IF EMPTY(cPassword)
            MSGBOX("Need Password")
            QUIT
         ELSE
            objWMIServices  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2",strComputer+"\"+cUser,cPassword)
         ENDIF
      ENDIF
   ELSE
      objWMIServices  := GetObject("WinMgmts:{impersonationLevel=impersonate}\\"+strComputer+"\Root\CIMv2") 
   ENDIF

   colItems       := objWMIServices:ExecQuery("select * from Win32_OperatingSystem",,48)
   bCollBlock     := {|oService,n| AADD(aItem,{ n,;
     oService:getProperty("BootDevice"),;
     oService:getProperty("BuildNumber"),;
     oService:getProperty("BuildType"),;
     oService:getProperty("Caption"),;
     oService:getProperty("CodeSet"),;
     oService:getProperty("CountryCode"),;
     oService:getProperty("CreationClassName"),;
     oService:getProperty("CSCreationClassName"),;
     oService:getProperty("CSDVersion"),;
     oService:getProperty("CSName"),;
     oService:getProperty("CurrentTimeZone"),;
     oService:getProperty("DataExecutionPrevention_32BitApplications"),;
     oService:getProperty("DataExecutionPrevention_Available"),;
     oService:getProperty("DataExecutionPrevention_Drivers"),;
     oService:getProperty("DataExecutionPrevention_SupportPolicy"),;
     oService:getProperty("Debug"),;
     oService:getProperty("Description"),;
     oService:getProperty("Distributed"),;
     oService:getProperty("EncryptionLevel"),;
     oService:getProperty("ForegroundApplicationBoost"),;
     oService:getProperty("FreePhysicalMemory"),;
     oService:getProperty("FreeSpaceInPagingFiles"),;
     oService:getProperty("FreeVirtualMemory"),;
     oService:getProperty("InstallDate"),;
     oService:getProperty("LargeSystemCache"),;
     oService:getProperty("LastBootUpTime"),;
     oService:getProperty("LocalDateTime"),;
     oService:getProperty("Locale"),;
     oService:getProperty("Manufacturer"),;
     oService:getProperty("MaxNumberOfProcesses"),;
     oService:getProperty("MaxProcessMemorySize"),;
     oService:getProperty("Name"),;
     oService:getProperty("NumberOfLicensedUsers"),;
     oService:getProperty("NumberOfProcesses"),;
     oService:getProperty("NumberOfUsers"),;
     oService:getProperty("Organization"),;
     oService:getProperty("OSLanguage"),;
     oService:getProperty("OSProductSuite"),;
     oService:getProperty("OSType"),;
     oService:getProperty("OtherTypeDescription"),;
     oService:getProperty("PlusProductID"),;
     oService:getProperty("PlusVersionNumber"),;
     oService:getProperty("Primary"),;
     oService:getProperty("ProductType"),;
     oService:getProperty("QuantumLength"),;
     oService:getProperty("QuantumType"),;
     oService:getProperty("RegisteredUser"),;
     oService:getProperty("SerialNumber"),;
     oService:getProperty("ServicePackMajorVersion"),;
     oService:getProperty("ServicePackMinorVersion"),;
     oService:getProperty("SizeStoredInPagingFiles"),;
     oService:getProperty("Status"),;
     oService:getProperty("SuiteMask"),;
     oService:getProperty("SystemDevice"),;
     oService:getProperty("SystemDirectory"),;
     oService:getProperty("SystemDrive"),;
     oService:getProperty("TotalSwapSpaceSize"),;
     oService:getProperty("TotalVirtualMemorySize"),;
     oService:getProperty("TotalVisibleMemorySize"),;
     oService:getProperty("Version") })}

   ComEvalCollection(colItems, bCollBlock )

   IF LEN(aItem) > 0
      ? "Win32_OperatingSystem"
      jMax := LEN(aItem)
      iMax := LEN(aItem[1])
      FOR j := 1 TO jMax
         ?"*****************************************************************************"
         FOR i := 1 TO iMax-1
            ? SUBSTR(aProp[i]+SPACE(40),1,40)+":",aItem[j,i+1]
         NEXT
         ?"*****************************************************************************"
      NEXT
   ELSE
      MSGBOX("no Property found ?")
   ENDIF

   SET ALTER OFF
   SET ALTER TO

   Runshell("Win32_OperatingSystem.TXT","Notepad.exe",.T.)

RETURN
